﻿Public Class BoardCell


    Public Status As CellStatus   'セルの状態。黒・白・空。
    Public Grid As BoardGrid
    Public Position As Point      '論理位置
    Public Rectangle As Rectangle '物理位置

    Public Focused As CellForcus

    Dim Rect As New Rectangle



#Region "Public Sub New"
    Public Sub New(ByVal Grid As BoardGrid, ByVal Position As Point)
        Me.Grid = Grid
        Me.Position = Position

        Rect.X = Position.X * BoardGrid.CellSize
        Rect.Y = Position.Y * BoardGrid.CellSize
        Rect.Width = BoardGrid.CellSize
        Rect.Height = BoardGrid.CellSize
        Me.Rectangle = Rect
    End Sub
#End Region



#Region "アクティブセルの枠を描画"
    Public Sub Draw_Waku(ByVal g As Graphics, ByVal IroD As String)
        '▼描画領域の算定
        Dim CellRect As Rectangle '描画領域
        CellRect = Me.Rectangle
        CellRect.Inflate(-5, -5)  '枠の大きさをセルより-5とする。

        If IroD = "Black" Then
            g.DrawEllipse(New Pen(Color.Black, 0.8), CellRect)
        ElseIf IroD = "White" Then
            g.DrawEllipse(New Pen(Color.White, 1.6), CellRect)
        End If
    End Sub
#End Region



#Region "石の描画"
    Public Sub Draw_Isi(ByVal g As Graphics, ByVal Bango As Integer)
        '▼描画領域の算定
        Dim CellRect As Rectangle '描画領域
        CellRect = Me.Rectangle
        CellRect.Inflate(-1, -1)  'セルいっぱいに描画するとぎちぎちになるので範囲を-1する。

        '▼描画状態の設定
        Dim BlackBrush As New SolidBrush(Color.Black)
        Dim WhiteBrush As New SolidBrush(Color.White)
        Dim BlackPen As New Pen(Color.Black, 1)
        Dim RedPen As New Pen(Color.Red, 2)

        If Me.Status <> CellStatus.Nothing Then
            Select Case Me.Status
                Case CellStatus.Black
                    g.FillEllipse(BlackBrush, CellRect)    '黒で塗りつぶし
                Case CellStatus.White
                    g.FillEllipse(WhiteBrush, CellRect)    '白で塗りつぶし
                    g.DrawEllipse(BlackPen, CellRect)      '白の輪郭を黒線で描く
            End Select

            '▼手順番号を描画しない場合は赤丸を描く
            If Bango = 0 Then Exit Sub '                   '置碁の石には赤丸を描かない

            If Item1(17).Checked = True Then
                Exit Sub
            ElseIf Item1(18).Checked = True Then
                If Bango = Ishi_Bango Then
                    CellRect.Inflate(-5, -5)                '枠の大きさをセルより-5とする。
                    g.DrawEllipse(RedPen, CellRect)         '赤丸
                End If
            End If
        End If
    End Sub
#End Region



#Region "着手手順番号の描画"
    Public Sub Draw_Bango(ByVal g As Graphics, ByVal Bango As Integer)
        '▼描画領域の算定
        Dim CellRect As Rectangle '描画領域
        CellRect = Me.Rectangle

        '▼描画状態の設定
        Dim CellFont1 As New Font("MS UI Gothic", 12, FontStyle.Underline)
        Dim CellFont2 As New Font("MS UI Gothic", 12, FontStyle.Bold)

        If Me.Status <> CellStatus.Nothing Then
            '▼桁数にかかわらず真ん中に表示
            Dim Format1 As New StringFormat(StringFormatFlags.NoClip)
            Format1.Alignment = StringAlignment.Center      '横方向
            Format1.LineAlignment = StringAlignment.Center  '縦方向

            '▼描画実行
            If Bango = Ishi_Bango Then
                g.DrawString(Bango, CellFont1, Brushes.Red, CellRect, Format1)           '赤色字

            Else
                Select Case Me.Status
                    Case CellStatus.Black
                        g.DrawString(Bango, CellFont2, Brushes.White, CellRect, Format1) '白色字
                    Case CellStatus.White
                        g.DrawString(Bango, CellFont2, Brushes.Black, CellRect, Format1) '黒色字
                End Select
            End If
        End If
    End Sub
#End Region



End Class
