﻿Public Class BoardGrid


    Public Const CellSize As Integer = 36 'セルのサイズ
    Public Const XCount As Integer = 19   '盤の横方向のセル数
    Public Const YCount As Integer = 19   '盤の縦方向のセル数

    Dim _Cells(18, 18) As BoardCell '全セルを表す配列



#Region "Public Sub New(ByVal PictureBox1 As PictureBox)"
    Public Sub New(ByVal PictureBox1 As PictureBox)
        '----------------361個のセルクラスを生成し、二次配列に格納
        For X As Integer = 0 To 18
            For Y As Integer = 0 To 18
                _Cells(X, Y) = New BoardCell(Me, New Point(X, Y))
            Next
        Next
    End Sub
#End Region



#Region " Public Property Cells(ByVal X As Integer, ByVal Y As Integer) As BoardCell"
    Public Property Cells(ByVal X As Integer, ByVal Y As Integer) As BoardCell
        '----------------外部からセルにアクセス可能とするプロパティ
        Get
            Return _Cells(X, Y)
        End Get

        Set(ByVal value As BoardCell)
            _Cells(X, Y) = value
        End Set
    End Property
#End Region



#Region "Public Sub Draw(ByVal g As Graphics, ByVal Grid As BoardGrid)"
    Public Sub Draw(ByVal g As Graphics, ByVal Grid As BoardGrid)
        Dim Pen1 As New Pen(Color.Black, 2)
        Dim Pen2 As New Pen(Color.Black, 1)
        Dim HoshiSize As Integer = 6

        '▼グリッドの描画
        '-----------------四角形
        'g.FillRectangle(Brushes.BlanchedAlmond, 0, 0, CInt(XCount * CellSize), CInt(YCount * CellSize))  '盤に色を塗る
        g.DrawRectangle(Pen1, CInt(XCount - 1), CInt(YCount - 1), CInt(XCount * CellSize - CellSize), _
                              CInt(YCount * CellSize - CellSize))                                        '盤の輪郭
        '-----------------縦の17本の線
        For X As Integer = 1 To XCount - 2
            g.DrawLine(Pen2, CInt((XCount - 1) + X * CellSize), CInt(XCount - 1), CInt((XCount - 1) + X * CellSize), _
                             CInt(XCount * CellSize - CellSize / 2))
        Next
        '-----------------横の17本の線
        For Y As Integer = 1 To YCount - 2
            g.DrawLine(Pen2, CInt(YCount - 1), CInt((YCount - 1) + Y * CellSize), CInt(YCount * CellSize - CellSize / 2), _
                             CInt((YCount - 1) + Y * CellSize))
        Next
        '-----------------９個の星
        For i As Integer = 108 To 540 Step 216
            For j As Integer = 108 To 540 Step 216
                g.FillEllipse(Brushes.Black, i + CInt(((XCount - 1) - HoshiSize / 2)), j + CInt(((YCount - 1) - HoshiSize / 2)), _
                              HoshiSize, HoshiSize)
            Next
        Next


        '▼アクティブセルの枠を描画
        Dim Pos As Point = PictureBox1.PointToClient(Windows.Forms.Cursor.Position)  'PictureBox1の座標を取得
        Dim X1 As Integer = CInt(Pos.X \ BoardGrid.CellSize)                         'セルの論理X座標
        Dim Y1 As Integer = CInt(Pos.Y \ BoardGrid.CellSize)                         'セルの論理Y座標


        If (X1 >= 0 And X1 <= BoardGrid.XCount - 1) And (Y1 >= 0 And Y1 <= BoardGrid.YCount - 1) Then
            If _Cells(X1, Y1).Focused = CellForcus.True Then                         'アクティブなセルのみ描画する
                Dim Ishi As IshiStatus = New IshiStatus
                Ishi.Ishi_Status(0, "")                                              '枠の色を決める(0ダミー)

                _Cells(X1, Y1).Draw_Waku(g, Ishi.Iro)                                '枠を描画
            End If
        End If


        '▼置碁の場合は置石を描画
        If Okigo = True Then
            For Y As Integer = 0 To YCount - 1
                For X As Integer = 0 To XCount - 1
                    _Cells(X, Y).Draw_Isi(g, 0)
                Next
            Next

            If Ishi_Bango = 0 Then
                Exit Sub
            End If
        End If


        '▼石と着手番号を描画

        For i As Integer = 0 To ArrayList1.Count - 4 Step 4
            Dim Bango As Integer = CInt(ArrayList1.Item(i))
            Dim X As Integer = CInt(ArrayList1.Item(i + 2))
            Dim Y As Integer = CInt(ArrayList1.Item(i + 3))

            '-----------------石を描画
            _Cells(X, Y).Draw_Isi(g, Bango)

            '-----------------着手番号を描画
            If Item1(17).Checked = True Then
                If OrderName = "印刷" Then
                    If Bango >= Start_Bango And Bango <= End_Bango Then
                        _Cells(X, Y).Draw_Bango(g, Bango)
                    End If
                Else
                    _Cells(X, Y).Draw_Bango(g, Bango)
                End If

                If Ishi_Bango = ArrayList1.Item(i) Then
                    Exit Sub
                End If
            End If
        Next

    End Sub
#End Region




End Class
