﻿Public Class Form1



#Region "Form1_Load⇒起動時の措置"
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '▼スクリーンの大きさ
        Dim Screen_Width As Integer = Screen.PrimaryScreen.Bounds.Width  '⇒1280
        Dim Screen_Heigh As Integer = Screen.PrimaryScreen.Bounds.Height '⇒1024

        '▼フォーム1の形をととのえスクリーンの真ん中に表示する
        Me.Size = New Size(1024, 820)
        Me.Location = New Point(CInt(Screen_Width \ 2 - Me.Width \ 2), CInt(Screen_Heigh \ 2 - Me.Height \ 2 - 30))
        Me.BackColor = Color.FromArgb(251, 250, 245) '生成り色
        Me.Text = "★　囲 碁 _ 棋 譜 の 作　成　★    　　<VB_2010>"

        '▼起動時のコントロールを貼付
        Dim BdCn As BoardControl = New BoardControl
        BdCn.Base_Control()
        BdCn.Panel1_Control()
        BdCn.Panel3_Control()

        '▼諸元の設定
        TextBox1(0).Text = Year(Now) - 1988
        TextBox1(1).Text = Month(Now)
        TextBox1(2).Text = Microsoft.VisualBasic.Day(Now)
        ComboBox1(0).SelectedIndex = ComboBox1(0).FindString("段")
        ComboBox1(1).SelectedIndex = ComboBox1(1).FindString("段")
        Item1(2).Enabled = False
        Item1(3).Enabled = False
        Item1(7).Checked = True
        Item1(17).Checked = True
        Item1(18).Checked = False
        TextBox1(3).Select()

        On Error Resume Next
        PlaySound(Onsei1, 0, SND_ASYNC)
    End Sub
#End Region



#Region "PictureBox1_Paint⇒線や石を描画する"
    Public Grid As BoardGrid = New BoardGrid(PictureBox1)

    Public Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs)

        Grid.Draw(e.Graphics, Grid)

    End Sub
#End Region



#Region "PictureBox1_MouseClick⇒石を描画し、着手番号を記入する"
    Public Sub PictureBox1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)

        PictureBox1.Select()      '焦点を持ってくる
        Button1(1).Enabled = True
        Item1(1).Enabled = False
        Item1(2).Enabled = True
        Item1(3).Enabled = True
        Item1(4).Enabled = True
        Item1(6).Enabled = False

        Dim Pos As Point = PictureBox1.PointToClient(Windows.Forms.Cursor.Position) 'PictureBox1の座標を取得
        Dim X As Integer = CInt(Pos.X \ BoardGrid.CellSize)                         'セルの論理X座標
        Dim Y As Integer = CInt(Pos.Y \ BoardGrid.CellSize)                         'セルの論理Y座標

        Select Case e.Button '-------------------------------------------------------マウスの左、右クリックの判定
            Case Windows.Forms.MouseButtons.Left

                '            ●++++++++++<<<左ボタンのクリック⇒石を描く>>>++++++++++●
                If Grid.Cells(X, Y).Status = CellStatus.Nothing Then '石の無い場所にのみ描画可能
                    On Error Resume Next
                    PlaySound(Onsei1, 0, SND_ASYNC)

                    Dim Ishi As IshiStatus = New IshiStatus
                    Ishi.Ishi_Status(0, "")                        '石の番号・色を決める(0ダミー)

                    Grid.Cells(X, Y).Status = Ishi.Cell_Status     '石を描く　
                    PictureBox1.Invalidate()                       'PictureBox1_Paintのイベントを発生して再描画を要求する
                    Label0(1).Text = Ishi.Label0Text

                    ArrayList1.Add(Ishi.Number)                    'ArrayList1に格納(石の番号・色を決めてから格納)
                    ArrayList1.Add(Ishi.Iro)
                    ArrayList1.Add(X)
                    ArrayList1.Add(Y)

                    Ishi_Bango = Ishi.Number
                    Dim Groups As Group = New Group(Ishi.Number, Ishi.Iro, X, Y)
                    Groups.Group_Form(Grid)                        '繋がった石でグループを作成し、ArrayListGに格納する
                    Groups.Enclose_Ishi(Grid)                      '囲まれた石を抽出し、その石を消す
                End If

            Case Windows.Forms.MouseButtons.Right

                '            ●++++++++++<<<右ボタンのクリック⇒石を消す>>>++++++++++●
                If Grid.Cells(X, Y).Status <> CellStatus.Nothing Then '石の有る場所にのみ消去可能

                    '▼石が有っても置き石は削除しない(置石はArrayList1に登録しない)
                    If ArrayList1.Count = 0 Then Exit Sub

                    '▼最後に描画したもののみ削除する
                    If X = CInt(ArrayList1.Item(ArrayList1.Count - 2)) And Y = CInt(ArrayList1.Item(ArrayList1.Count - 1)) Then
                        On Error Resume Next
                        PlaySound(Onsei1, 0, SND_ASYNC)

                        Call 石のクリヤー(Grid)

                        '▼ArrayList1の最後から４文字を削除
                        ArrayList1.RemoveRange(ArrayList1.Count - 4, 4)
                        ArrayList1.TrimToSize()

                        '▼ArrayList1のデータ数が0となった場合画面を初期化する
                        If ArrayList1.Count = 0 Then
                            Button1(1).Enabled = False
                            Item1(1).Enabled = True
                            Item1(2).Enabled = False
                            Item1(3).Enabled = False
                            Item1(4).Enabled = True
                            Item1(5).Enabled = False
                            Item1(7).Enabled = True
                            TextBox1(3).Select()
                            Label0(1).Text = "☆ 「全ての石」を削除しました。"

                            If Okigo = False Then
                                Label0(1).Text = "互　　　　　戦"
                                Label0(2).Text = "(互　　　戦)"
                            ElseIf Okigo = True Then
                                Dim Hdc As Handicap = New Handicap(OkigoMoku)
                                Hdc.Mokusu(Grid)
                                Label0(1).Text = Hdc.MyLabel1
                                Label0(2).Text = Hdc.MyLabel2
                                Button1(1).Enabled = True
                            End If
                            Exit Sub
                        End If

                        '▼置碁の場合は石を置き直す
                        If Okigo = True Then
                            Dim Hdc As Handicap = New Handicap(OkigoMoku)
                            Hdc.Mokusu(Grid)
                            Label0(1).Text = Hdc.MyLabel1
                            Label0(2).Text = Hdc.MyLabel2
                        End If

                        '▼４文字削除後のArrayList1のデータ通り石と手順番号を再描画する
                        For i As Integer = 0 To ArrayList1.Count - 4 Step 4
                            Call 石と手順番号を描画(Grid, CInt(ArrayList1.Item(i)), CStr(ArrayList1.Item(i + 1)), _
                                                          CInt(ArrayList1.Item(i + 2)), CInt(ArrayList1.Item(i + 3)))
                        Next

                        '▼ラベルの表示
                        If CStr(ArrayList1.Item(ArrayList1.Count - 3)) = "Black" Then
                            Label0(1).Text = "☆ 「白石 " & CInt(ArrayList1.Item(ArrayList1.Count - 4)) + 1 & "」を削除しました。"
                        ElseIf CStr(ArrayList1.Item(ArrayList1.Count - 3)) = "White" Then
                            Label0(1).Text = "☆ 「黒石 " & CInt(ArrayList1.Item(ArrayList1.Count - 4)) + 1 & "」を削除しました。"
                        End If
                    End If
                End If
        End Select

        'Trueは盤面に変化あり⇒保存するかを聞く、Falseは盤面変化なし⇒保存するかを聞かないで終了
        Hozon = True
    End Sub

#End Region



#Region "PictureBox1_MouseMove⇒マウスの移動に伴ってセルにアクティブを示す枠を描画する"
    Public Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        '▼すべてのセルを非アクティブにする
        For a As Integer = 0 To BoardGrid.XCount - 1
            For b As Integer = 0 To BoardGrid.YCount - 1
                Grid.Cells(a, b).Focused = CellForcus.False
            Next
        Next
        PictureBox1.Invalidate()

        '▼PictureBox1の座標を取得
        Dim Pos As Point = PictureBox1.PointToClient(Windows.Forms.Cursor.Position)
        Dim X As Integer = CInt(Pos.X \ BoardGrid.CellSize)           'セルの論理X座標
        Dim Y As Integer = CInt(Pos.Y \ BoardGrid.CellSize)           'セルの論理Y座標

        '▼枠を描画する
        If (X >= 0 And X <= BoardGrid.XCount - 1) And (Y >= 0 And Y <= BoardGrid.YCount - 1) Then
            If Grid.Cells(X, Y).Status = CellStatus.Nothing Then      '石の無い場所にのみ描画可能
                Grid.Cells(X, Y).Focused = CellForcus.True            '自分自身をアクティブにする
            End If
        End If
        PictureBox1.Invalidate()                                      'PictureBox1_Paintのイベントを発生して再描画を要求する
    End Sub
#End Region



#Region "PictureBox1_MouseLeave⇒マウスがピクチャーボックスから外れた場合"
    Public Sub PictureBox1_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs)
        '▼すべてのセルを非アクティブにする
        For a As Integer = 0 To BoardGrid.XCount - 1
            For b As Integer = 0 To BoardGrid.YCount - 1
                Grid.Cells(a, b).Focused = CellForcus.False
            Next
        Next
        PictureBox1.Invalidate()
    End Sub
#End Region



#Region "Item1_Click⇒メニューをクリックする"


#Region "メイン⇒Item1_Click"
    Public Sub Item1_Click(ByVal sender As Object, ByVal e As System.EventArgs)

        Select Case CInt(sender.tag)
            Case 0 '--------------------------ファイル(&F)
                Exit Sub
            Case 1 '--------------------------開　  く(&O)
                OrderName = "開く"
                Call 開く()
            Case 2 '--------------------------上書き保存(&S)
                OrderName = "上書き保存"
                Call 保存する()
            Case 3 '--------------------------名前を付けて保存(&A)
                OrderName = "名前を付けて保存"
                Call 保存する()
            Case 4 '--------------------------印  　刷(&P)
                OrderName = "印刷"
                Call 印刷する()
            Case 5 '--------------------------終　　了(&E)
                Call 終了する()
            Case 6 '--------------------------置　  碁(&R)
                Exit Sub
            Case 7 '--------------------------互　　戦(&S)
                Call 置石を置く(7, 1)
                '数字 前→Itemのチェック表示場所　後→置石の数(但し１は互戦)
            Case 8 '--------------------------２　　子(&T)
                Call 置石を置く(8, 2)
            Case 9 '--------------------------３　　子(&U)
                Call 置石を置く(9, 3)
            Case 10 '-------------------------４　　子(&C)
                Call 置石を置く(10, 4)
            Case 11 '-------------------------５　　子(&D)
                Call 置石を置く(11, 5)
            Case 12 '-------------------------６　　子(&F)
                Call 置石を置く(12, 6)
            Case 13 '-------------------------７　　子(&G)
                Call 置石を置く(13, 7)
            Case 14 '-------------------------８　　子(&I)
                Call 置石を置く(14, 8)
            Case 15 '-------------------------９　　子(&J)
                Call 置石を置く(15, 9)
            Case 16 '-------------------------表　　示(&S)
                Exit Sub
            Case 17 '-------------------------手順番号を表示する(&T)
                Call 手順番号を表示する()
            Case 18 '-------------------------手順番号を表示しない(&U)
                Call 手順番号を表示しない()
            Case 19 '-------------------------ヘ ル プ(&H)
                Call ヘルプ()
        End Select

    End Sub
#End Region


#Region "サブ⇒開く"
    Public OpenFileDialog1 As OpenFileDialog

    Private Sub 開く()

        '▼オープンファイルダイアログの設定
        OpenFileDialog1 = New OpenFileDialog
        With OpenFileDialog1
            .Title = "ファイルを選択してください (削除はファイルを右クリックします)"
            .FileName = "ファイルを選択してください"
            .RestoreDirectory = True
            .InitialDirectory = FPath & "My Data"
            .Filter = "テキストファイル(*.txt)|*.txt"
        End With

        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            '-----------------------------------------------------------------ファイルを開く
            Dim BdCn As BoardControl = New BoardControl
            BdCn.Panel1_Control()
            BdCn.Panel2_RePlay_Control()

            Call 盤面の全クリアー(Grid)
            Call 盤面の初期設定(Grid, OpenFileDialog1)

            PictureBox1.Enabled = False
            Item1(0).Enabled = False
            Item1(6).Enabled = False
            Button2(0).Enabled = True
            Button2(1).Enabled = False
            Button2(2).Enabled = False
            Button2(3).Enabled = False
            Button2(4).Enabled = True
            Button2(5).Enabled = True
            Button2(6).Enabled = False
            RadioButton1(0).Enabled = True
            RadioButton1(1).Enabled = True
            RadioButton1(2).Enabled = True
            Label0(3).Text = "★ 再生画面です。自動または手動で再生してください。"
            Label2(0).Text = " ★ 「" & IO.Path.GetFileNameWithoutExtension(OpenFileDialog1.FileName) & _
                             "」を再生します。" & vbLf & vbLf & "  下の「自動再生」又は「手動再生」" & vbLf & "  をクリックして下さい。"

        ElseIf Windows.Forms.DialogResult.Cancel Then
            '-----------------------------------------------------------------キャンセルする
            'Me.Select()
            Exit Sub
        End If

    End Sub
#End Region

#Region "サブ⇒保存する"
    Public Sub 保存する()
        '-------------------------------------------------------------------フォルダの存在を確認し、なければ作る
        If System.IO.Directory.Exists(FPath & "My Data") Then
            GoTo trap
        Else
            System.IO.Directory.CreateDirectory(FPath & "My Data")
        End If
trap:
        '-------------------------------------------------------------------SaveFileDialog1の諸元の設定
        Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
        With SaveFileDialog1
            Select Case OrderName
                Case "名前を付けて保存", "印刷", "削除", ""
                    .Title = "名前を付けて保存"        'タイトル名を表示
                    .CreatePrompt = False              '新しく作成するかどうかの問い合わせを表示する(初期値 False)
                    .OverwritePrompt = True            '上書きするかどうかの問い合わせを表示する(初期値 True)
                    .FileName = "新しいファイル名.txt" '初期表示するファイル名を設定する
                    .CheckPathExists = True            '存在しないパスを指定した場合は警告を表示する(初期値 True)
                    .CheckFileExists = False           '存在しないファイル名を指定した場合は警告を表示する(初期値 False)
                Case "上書き保存", "開く"
                    .Title = "上書き保存"
                    .CreatePrompt = True
                    .OverwritePrompt = False
                    .FileName = MyfileName             '開いたファイルの名前を表示する
                    .CheckPathExists = False
                    .CheckFileExists = True
            End Select
            .DefaultExt = "txt"                        '拡張子を指定しない場合は自動的に拡張子を付加する
            .RestoreDirectory = True                   'ダイアログボックスを閉じる前に現在のディレクトリを復元する(初期値 False)
            .InitialDirectory = FPath & "My Data"      '初期表示するディレクトリを設定する
            .Filter = "テキストファイル(*.txt)|*.txt"
        End With

        '-----------------------------------------------------------------------SaveFileDialog1を表示し、保存するかどうかを確認する
        If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            '▼保存する
            Dim Ans As String = MsgBox("ファイル名を　「" & IO.Path.GetFileNameWithoutExtension(SaveFileDialog1.FileName) & _
                                       "」　で保存します。", MsgBoxStyle.YesNo + MsgBoxStyle.Information, "保存")
            If Ans = MsgBoxResult.Yes Then
                Dim Writer As New System.IO.StreamWriter(SaveFileDialog1.FileName, False, System.Text.Encoding.GetEncoding("shift_jis"))

                Writer.WriteLine("ファイル名=" & "," & MyfileName & "," & Okigo & "," & OkigoMoku)
                'Writer.WriteLine("ファイル名=" & "," & SaveFileDialog1.FileName & "," & Okigo & "," & OkigoMoku)
                Writer.WriteLine("対局日" & "," & TextBox1(0).Text & "," & TextBox1(1).Text & "," & TextBox1(2).Text)
                Writer.WriteLine("白" & "," & TextBox1(3).Text & "," & TextBox1(5).Text & "," & ComboBox1(0).Text)
                Writer.WriteLine("黒" & "," & TextBox1(4).Text & "," & TextBox1(6).Text & "," & ComboBox1(1).Text)

                For i As Integer = 0 To ArrayList1.Count - 4 Step 4
                    Writer.WriteLine(ArrayList1.Item(i) & "," & ArrayList1.Item(i + 1) & "," & ArrayList1.Item(i + 2) & "," & ArrayList1.Item(i + 3))
                Next
                Writer.Close()
                Writer.Dispose()

                Hozon = False '保存済となったので元に戻す
            ElseIf Ans = MsgBoxResult.No Then
                Me.Select()
                Exit Sub
            End If

            System.Threading.Thread.Sleep(600)
            Dim Ans2 As String = MsgBox("保存しました。終了します。", MsgBoxStyle.OkCancel + MsgBoxStyle.Information, "終了")
            If Ans2 = MsgBoxResult.Ok Then
                Me.Close()
                Me.Dispose()

            ElseIf Ans2 = MsgBoxResult.Cancel Then
                Me.Select()
                Exit Sub
            End If

        ElseIf Windows.Forms.DialogResult.Cancel Then
            '▼キャンセルする
            Me.Select()
            Exit Sub
        End If

    End Sub
#End Region

#Region "サブ⇒印刷する"
    Private Sub 印刷する()
        Item1(17).Checked = True
        Item1(18).Checked = False

        If ArrayList1.Contains("Black") Then '------------------------------------------盤面に石の表示がある場合
            '▼コントロールの表示
            Dim BdCn As BoardControl = New BoardControl
            BdCn.Panel1_Control()
            BdCn.Panel2_Print_Control()

            '▼着手番号の印字範囲を指定する
            Start_Bango = 1
            End_Bango = CInt(ArrayList1.Item(ArrayList1.Count - 4))

            PictureBox1.Enabled = False
            Item1(0).Enabled = False
            Item1(7).Enabled = False
            Label0(1).Text = "印刷画面です。この棋譜を印刷します。"
            Label0(3).Text = "印刷画面です。画面にはアクセスできません。"

        Else '---------------------------------------------------------------------------盤面に石の表示が無く呼び出す場合
            OpenFileDialog1 = New OpenFileDialog
            With OpenFileDialog1
                .Title = "印刷する棋譜を選択してください"
                .FileName = "ファイルを選択してください"
                .RestoreDirectory = True
                .InitialDirectory = FPath & "My Data"
                .Filter = "テキストファイル(*.txt)|*.txt"
            End With


            If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then

                Call 盤面の全クリアー(Grid)
                Call 盤面の初期設定(Grid, OpenFileDialog1)

                '▼コントロールの貼付
                Dim BdCn As BoardControl = New BoardControl
                BdCn.Panel1_Control()
                BdCn.Panel2_Print_Control()

                '▼着手番号の印字範囲を指定する(呼出時なのですべてを表示する)
                Start_Bango = 1
                End_Bango = CInt(ArrayList1.Item(ArrayList1.Count - 4))

                '▼ArrayList1のデータ通り石と手順番号を再描画する
                For i As Integer = 0 To ArrayList1.Count - 4 Step 4
                    Call 石と手順番号を描画(Grid, CInt(ArrayList1.Item(i)), CStr(ArrayList1.Item(i + 1)), _
                                                  CInt(ArrayList1.Item(i + 2)), CInt(ArrayList1.Item(i + 3)))
                Next

                Hozon = False
                PictureBox1.Enabled = False
                Item1(0).Enabled = False
                Item1(6).Enabled = False
                Label0(1).Text = "印刷画面です。この棋譜を印刷します。"
                Label0(3).Text = "印刷画面です。画面にはアクセスできません。"

            ElseIf Windows.Forms.DialogResult.Cancel Then
                '--------------------------------------------------------------------------キャンセルする
                Exit Sub
            End If


        End If
    End Sub
#End Region

#Region "サブ⇒終了する"
    Private Sub 終了する()

        If ArrayList1.Count = 0 Then
            '▼盤面に石の表示が無い場合は即終了
            Me.Close()
            Me.Dispose()

        Else
            '▼盤面に石の表示がある場合は、保存するか聞く
            If Hozon = True Then 'Hozon = True⇒盤面で変化あり、保存するかどうか聞く
                Dim Ans As String = MsgBox("この棋譜は保存されていません。保存しますか?", MsgBoxStyle.YesNo + MsgBoxStyle.Information, "保存")
                If Ans = MsgBoxResult.Yes Then
                    Call 保存する()

                ElseIf Ans = MsgBoxResult.No Then
                    Dim Ans2 As String = MsgBox("保存しないで、終了します。", MsgBoxStyle.OkCancel + MsgBoxStyle.Information, "保存")
                    If Ans2 = MsgBoxResult.Ok Then
                        Me.Close()
                        Me.Dispose()
                    ElseIf Ans2 = MsgBoxResult.Cancel Then
                        Exit Sub
                    End If
                End If
            ElseIf Hozon = False Then
                Me.Close()
                Me.Dispose()
            End If
        End If

    End Sub
#End Region

#Region "サブ⇒置石を置く"
    Private Sub 置石を置く(ByVal a As Integer, ByVal b As Integer)
        '▼チェックマークの表示
        For i As Integer = 7 To 15
            Item1(i).Checked = False
        Next
        Item1(a).Checked = True

        Call 石のクリヤー(Grid)
        Ishi_Bango = 0
        ArrayList1.Clear()
        ArrayList1.TrimToSize()

        Dim Hdc As Handicap = New Handicap(b)
        Hdc.Mokusu(Grid) '石を置く

        Label0(1).Text = Hdc.MyLabel1
        Label0(2).Text = Hdc.MyLabel2
        Button1(1).Enabled = True
        Item1(1).Enabled = False
        Item1(2).Enabled = False
        Item1(3).Enabled = False
        Item1(4).Enabled = False
    End Sub
#End Region

#Region "サブ⇒手順番号を表示する"
    Private Sub 手順番号を表示する()
        Item1(17).Checked = True
        Item1(18).Checked = False

    End Sub
#End Region

#Region "サブ⇒手順番号を表示しない"
    Private Sub 手順番号を表示しない()
        Item1(17).Checked = False
        Item1(18).Checked = True

    End Sub
#End Region

#Region "サブ⇒ヘルプ"
    Private Sub ヘルプ()
        Form2.Show()

        PictureBox1.Enabled = False
        Me.Enabled = False
    End Sub
#End Region


#End Region



#Region "Button1_Click⇒ボタン１をクリックする"
    Public Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        On Error GoTo Trap

        Select Case CInt(CType(sender, Button).Tag)
            Case 0 '--------------------------------終了
                Call 終了する()

            Case 1 '--------------------------------盤面の全クリヤー
                Dim Ans As String = MsgBox("盤面のすべての石と対局者名を消去します。よろしいですか?", _
                                            MsgBoxStyle.OkCancel + MsgBoxStyle.Information, "盤面の全クリヤー")
                If Ans = MsgBoxResult.Ok Then
                    Call 盤面の全クリアー(Grid)
                ElseIf Ans = MsgBoxResult.Cancel Then
                    Exit Select
                End If
        End Select

        Exit Sub
Trap:
        MsgBox(Err.Number & "  (Button1(0)～(1)_Click⇒ボタンをクリックする)  :  " & Err.Description)
        Resume Next
    End Sub
#End Region



#Region "Button2_Click⇒ボタン２をクリックする"
    Private Ar_Index As Integer = -4         'ArrayList1(0)のIndex⇒手順番号のIndex、Ishi_Bango (0から4つずつ飛び)
    Private Canceled As Boolean = False      'キャンセルボタンがクリックされたか
    Private Page As Integer = 0              '印刷ページ


#Region "メイン⇒Button2_Click"
    Public Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Select Case OrderName
            Case "開く" '⇒再生
                Select Case CInt(CType(sender, Button).Tag)
                    Case 0 '--------------------------------------------------自動再生
                        If Ar_Index > CInt(ArrayList1.Count) - 4 Then
                            Ar_Index = CInt(ArrayList1.Count) - 4
                            Exit Sub
                        End If

                        '▼待機時間の設定
                        Dim MyTime As Integer
                        If RadioButton1(0).Checked = True Then
                            MyTime = 1000
                        ElseIf RadioButton1(1).Checked = True Then
                            MyTime = 3000
                        ElseIf RadioButton1(2).Checked = True Then
                            MyTime = 5000
                        End If

                        Ar_Index = Ishi_Bango * 4
                        Call 自動再生(MyTime)
                        Ar_Index = (Ishi_Bango - 1) * 4

                        '▼次の中止に備えフラッグを元に戻す
                        Canceled = False
                    Case 1 '--------------------------------------------------自動再生中止(フラッグを立てる)
                        Canceled = True

                    Case 2 '--------------------------------------------------｜<<最初へ
                        Call 最初へ()
                        Ar_Index = -4

                    Case 3 '--------------------------------------------------戻る
                        Ar_Index -= 4
                        If Ar_Index < -4 Then
                            Ar_Index = -4
                            Exit Sub
                        End If

                        Call 戻る()
                        Ar_Index = (Ishi_Bango - 1) * 4

                    Case 4 '--------------------------------------------------進む
                        Ar_Index += 4

                        If Ishi_Bango = 0 Then
                            Ar_Index = 0
                        End If

                        If Ar_Index > CInt(ArrayList1.Count) - 4 Then
                            Ar_Index = CInt(ArrayList1.Count) - 4
                            Exit Sub
                        End If

                        Call 進む()
                        Ar_Index = (Ishi_Bango - 1) * 4

                    Case 5 '-------------------------------------------------->>｜最後へ
                        Ar_Index = 0
                        Call 最後へ()
                        Ar_Index = CInt(ArrayList1.Count) - 4

                    Case 6 '--------------------------------------------------再生終了
                        OrderName = "" 'Panel1,2を中央に貼り付けるため
                        Dim BdCn As BoardControl = New BoardControl
                        BdCn.Panel1_Control()
                        BdCn.Panel3_Control()
                        OrderName = "開く" '保存時ファイル名を表示するため

                        '▼ArrayList1の内容を画面表示にあわせる
                        ArrayList1.RemoveRange(Ishi_Bango * 4, ArrayList1.Count - Ishi_Bango * 4)
                        ArrayList1.TrimToSize()

                        Try
                            Ishi_Bango = CInt(ArrayList1.Item(ArrayList1.Count - 4))
                            Ar_Index = CInt(ArrayList1.Count) - 4
                        Catch ex As Exception
                            Ishi_Bango = 0
                            Ar_Index = -4
                        End Try

                        PictureBox1.Enabled = True
                        Button1(1).Enabled = True
                        Item1(0).Enabled = True
                        Item1(1).Enabled = False
                        Item1(2).Enabled = True
                        Item1(3).Enabled = True
                        Item1(4).Enabled = True

                        Label0(1).Text = "再生は終了しました。盤面にマウスでアクセス出来ます。"
                        Label0(3).Text = "★ 数字が赤色でアンダーラインのある石は、マウスの 「右ボタン」 クリックで 「取り消す」 ことが出来ます。"
                End Select
                Hozon = True 'Trueは盤面に変化あり⇒保存するかを聞く、Falseは盤面変化なし⇒保存するかを聞かないで終了


            Case "印刷"
                Ck = False

                Try
                    PlaySound(Onsei1, 0, SND_ASYNC)
                Catch ex As Exception
                    Exit Try
                End Try

                Select Case CInt(CType(sender, Button).Tag)
                    Case 0 '--------------------------------------------------第1譜印刷 表示
                        Page = 1
                        Call 印刷データのチェック(0, 5, Page)
                        If Ck = True Then Exit Sub
                        Call 印刷データの表示(0, 5)
                        CurrentPage = 0   '印刷ページのクリアー
                    Case 1 '--------------------------------------------------第2譜印刷 表示
                        Page = 2
                        Call 印刷データのチェック(1, 6, Page)
                        If Ck = True Then Exit Sub
                        Call 印刷データの表示(1, 6)
                        CurrentPage = 0
                    Case 2 '--------------------------------------------------第3譜印刷 表示
                        Page = 3
                        Call 印刷データのチェック(2, 7, Page)
                        If Ck = True Then Exit Sub
                        Call 印刷データの表示(2, 7)
                        CurrentPage = 0
                    Case 3 '--------------------------------------------------第4譜印刷 表示
                        Page = 4
                        Call 印刷データのチェック(3, 8, Page)
                        If Ck = True Then Exit Sub
                        Call 印刷データの表示(3, 8)
                        CurrentPage = 0
                    Case 4 '--------------------------------------------------第5譜印刷 表示
                        Page = 5
                        Call 印刷データのチェック(4, 9, Page)
                        If Ck = True Then Exit Sub
                        Call 印刷データの表示(4, 9)
                        CurrentPage = 0
                    Case 5 '--------------------------------------------------第1譜印刷 印刷
                        Start_Bango = CInt(TextBox2(0).Text)
                        End_Bango = CInt(TextBox2(5).Text)
                        Call 印刷()
                        CurrentPage = 0   '印刷ページのクリアー
                    Case 6 '--------------------------------------------------第2譜印刷 印刷
                        Start_Bango = CInt(TextBox2(1).Text)
                        End_Bango = CInt(TextBox2(6).Text)
                        Call 印刷()
                        CurrentPage = 0
                    Case 7 '--------------------------------------------------第3譜印刷 印刷
                        Start_Bango = CInt(TextBox2(2).Text)
                        End_Bango = CInt(TextBox2(7).Text)
                        Call 印刷()
                        CurrentPage = 0
                    Case 8 '--------------------------------------------------第4譜印刷 印刷
                        Start_Bango = CInt(TextBox2(3).Text)
                        End_Bango = CInt(TextBox2(8).Text)
                        Call 印刷()
                        CurrentPage = 0
                    Case 9 '--------------------------------------------------第5譜印刷 印刷
                        Start_Bango = CInt(TextBox2(4).Text)
                        End_Bango = CInt(TextBox2(9).Text)
                        Call 印刷()
                        CurrentPage = 0
                    Case 10 '-------------------------------------------------終了
                        Dim Ans1 As String = MsgBox("印刷画面を終了します。よろしいですか?", _
                                                    MsgBoxStyle.YesNo + MsgBoxStyle.Information, "印刷画面の終了")
                        If Ans1 = MsgBoxResult.Yes Then

                            If Hozon = True Then               'Hozon = True⇒盤面で変化あり、保存するかどうか聞く
                                Dim Ans2 As String = MsgBox("この棋譜は保存されていません。保存しますか?", _
                                                            MsgBoxStyle.YesNo + MsgBoxStyle.Information, "保存")
                                If Ans2 = MsgBoxResult.Yes Then
                                    Call 保存する()
                                ElseIf Ans2 = MsgBoxResult.No Then
                                    MsgBox("保存しないで、終了します。")
                                End If
                            End If

                            OrderName = ""
                            Dim BdCn As BoardControl = New BoardControl
                            BdCn.Panel1_Control()
                            BdCn.Panel3_Control()

                            Call 盤面の全クリアー(Grid)
                            Button1(0).Enabled = True
                            Button1(1).Enabled = False

                            Item1(0).Enabled = True
                            Item1(6).Enabled = True

                        ElseIf Ans1 = MsgBoxResult.No Then
                            Exit Sub
                        End If
                    Case 11 '-------------------------------------------------印刷プレビュー
                        Call 印刷プレビュー()
                        Button2(11).Enabled = False
                End Select
            Case Else
                Exit Select
        End Select
    End Sub
#End Region


#Region "サブ⇒自動再生"
    Public Sub 自動再生(ByVal MyTime As Integer)
        Button2(0).Enabled = False
        Button2(1).Enabled = True
        Button2(2).Enabled = False
        Button2(3).Enabled = False
        Button2(4).Enabled = False
        Button2(5).Enabled = False
        Button2(6).Enabled = False
        RadioButton1(0).Enabled = False
        RadioButton1(1).Enabled = False
        RadioButton1(2).Enabled = False

        '▼ArrayList1のデータ通り石と手順番号を再描画する
        For i As Integer = Ar_Index To ArrayList1.Count - 4 Step 4
            If ArrayList1.Item(i + 1) = "Black" Then
                Label2(0).Text = "　　   ◎ 自動で再生中です。" & vbLf & vbLf & "           黒石 " & ArrayList1.Item(i) & " 手目" & vbLf
            ElseIf ArrayList1.Item(i + 1) = "White" Then
                Label2(0).Text = "　　   ◎ 自動で再生中です。" & vbLf & vbLf & "           白石 " & ArrayList1.Item(i) & " 手目" & vbLf
            End If

            On Error Resume Next
            PlaySound(Onsei1, 0, SND_ASYNC)

            Call 石と手順番号を描画(Grid, CInt(ArrayList1.Item(i)), CStr(ArrayList1.Item(i + 1)), _
                                          CInt(ArrayList1.Item(i + 2)), CInt(ArrayList1.Item(i + 3)))
            '▼再生時間を調整する
            If MyTime <> 0 Then                                            '待機時間が0で無い場合
                If Canceled Then                                           'キャンセルボタンがクリックされたか調べる
                    MessageBox.Show("自動再生を中止します。")
                    Label2(0).Text = "  ◎ 自動再生は「中止」されました。" & vbLf & vbLf & "       "
                    GoTo trap                                              'ループを抜ける
                End If

                Application.DoEvents()                                     '待機中のイベントを処理する
                System.Threading.Thread.Sleep(MyTime)                      'MyTimeの時間待機する
            End If
        Next

        '▼自動再生が終了した場合
        Label2(0).Text = "      ◎ 再生終了です。" & vbLf & vbLf & "    最終着手は「" & ArrayList1.Item(ArrayList1.Count - 4) & "手目」です。" & vbLf & vbLf _
                          & "  盤面にアクセスするには再生終了ボ" & vbLf & "  タンをクリックして下さい。"
        Label0(1).Text = "☆　「" & ArrayList1.Item(ArrayList1.Count - 4) & "手目」で 再生終了です。"
        Label0(3).Text = "★ 再生終了です。盤面にアクセスするには再生終了ボタンをクリックして下さい。"

        Button2(0).Enabled = False
        Button2(1).Enabled = False
        Button2(2).Enabled = True
        Button2(3).Enabled = True
        Button2(4).Enabled = False
        Button2(5).Enabled = False
        Button2(6).Enabled = True
        RadioButton1(0).Enabled = False
        RadioButton1(1).Enabled = False
        RadioButton1(2).Enabled = False
        Exit Sub
trap:
        Button2(0).Enabled = True
        Button2(1).Enabled = False
        Button2(2).Enabled = True
        Button2(3).Enabled = True
        Button2(4).Enabled = True
        Button2(5).Enabled = True
        Button2(6).Enabled = True
        RadioButton1(0).Enabled = True
        RadioButton1(1).Enabled = True
        RadioButton1(2).Enabled = True
    End Sub
#End Region

#Region "サブ⇒最初へ"
    Private Sub 最初へ()
        Call 石のクリヤー(Grid)
        Label2(0).Text = "     　◎ 最初に戻りました。" & vbLf & vbLf & "  　　　最初から再生できます。" & vbLf & vbLf & "       "
        Label0(1).Text = "  最初に戻りました。"
        Label0(3).Text = "★ 最初に戻りました。最初から再生できます。"
        Ishi_Bango = 0

        On Error Resume Next
        PlaySound(Onsei1, 0, SND_ASYNC)

        '▼置碁の場合は石を置き直す
        If Okigo = True Then
            Dim Hdc As Handicap = New Handicap(OkigoMoku)
            Hdc.Mokusu(Grid)
            Label0(2).Text = Hdc.MyLabel2
        End If

        Button2(0).Enabled = True
        Button2(1).Enabled = False
        Button2(2).Enabled = False
        Button2(3).Enabled = False
        Button2(4).Enabled = True
        Button2(5).Enabled = True
        Button2(6).Enabled = True
        RadioButton1(0).Enabled = True
        RadioButton1(1).Enabled = True
        RadioButton1(2).Enabled = True
    End Sub
#End Region

#Region "サブ⇒戻る"
    Private Sub 戻る()
        Button2(0).Enabled = True
        Button2(1).Enabled = False
        Button2(2).Enabled = True
        Button2(3).Enabled = True
        Button2(4).Enabled = True
        Button2(5).Enabled = True
        Button2(6).Enabled = True
        RadioButton1(0).Enabled = True
        RadioButton1(1).Enabled = True
        RadioButton1(2).Enabled = True
        Label0(3).Text = "★ 再生画面です。自動または手動で再生してください。"

        Call 石のクリヤー(Grid)

        '▼置碁の場合は石を置き直す
        If Okigo = True Then
            Dim Hdc As Handicap = New Handicap(OkigoMoku)
            Hdc.Mokusu(Grid)
            Label0(1).Text = Hdc.MyLabel1
            Label0(2).Text = Hdc.MyLabel2
        End If

        On Error Resume Next
        PlaySound(Onsei1, 0, SND_ASYNC)

        '▼４文字削除後のArrayList1のデータ通り石と手順番号を再描画する
        For i As Integer = 0 To Ar_Index Step 4
            Call 石と手順番号を描画(Grid, CInt(ArrayList1.Item(i)), CStr(ArrayList1.Item(i + 1)), _
                                          CInt(ArrayList1.Item(i + 2)), CInt(ArrayList1.Item(i + 3)))
        Next

        If ArrayList1.Item(Ishi_Bango * 4 - 3) = "Black" Then
            Label2(0).Text = "　　   ◎ 手動で戻っています。" & vbLf & vbLf & "   　　　白石 " & ArrayList1.Item(Ishi_Bango * 4 - 4) + 1 & " 手目を削除" & vbLf
        ElseIf ArrayList1.Item(Ishi_Bango * 4 - 3) = "White" Then
            Label2(0).Text = "　　   ◎ 手動で戻っています。" & vbLf & vbLf & "   　　　黒石 " & ArrayList1.Item(Ishi_Bango * 4 - 4) + 1 & " 手目を削除" & vbLf
        End If

        '▼画面に石が無くなった場合(最初に戻った場合)
        If Ar_Index = -4 Then
            Ishi_Bango = 0

            Label2(0).Text = "     　◎ 最初に戻りました。" & vbLf & vbLf & "  　　　最初から再生できます。" & vbLf & vbLf ' & "       "
            Label0(1).Text = "最初に戻りました。"
            Label0(3).Text = "★ 最初に戻りました。最初から再生できます。"
            Button2(0).Enabled = True
            Button2(1).Enabled = False
            Button2(2).Enabled = False
            Button2(3).Enabled = False
            Button2(4).Enabled = True
            Button2(5).Enabled = True
            Button2(6).Enabled = True
            RadioButton1(0).Enabled = True
            RadioButton1(1).Enabled = True
            RadioButton1(2).Enabled = True
        End If
    End Sub
#End Region

#Region "サブ⇒進む"
    Private Sub 進む()
        If CInt(ArrayList1.Item(ArrayList1.Count - 4)) >= Ishi_Bango Then
            Button2(0).Enabled = True
            Button2(1).Enabled = False
            Button2(2).Enabled = True
            Button2(3).Enabled = True
            Button2(4).Enabled = True
            Button2(5).Enabled = True
            Button2(6).Enabled = True
            RadioButton1(0).Enabled = True
            RadioButton1(1).Enabled = True
            RadioButton1(2).Enabled = True

            If ArrayList1.Item(Ishi_Bango * 4 + 1) = "Black" Then
                Label2(0).Text = "　　   ◎ 手動で再生中です。" & vbLf & vbLf & "           黒石 " & ArrayList1.Item(Ishi_Bango * 4) & " 手目" & vbLf
            ElseIf ArrayList1.Item(Ishi_Bango * 4 + 1) = "White" Then
                Label2(0).Text = "　　   ◎ 手動で再生中です。" & vbLf & vbLf & "           白石 " & ArrayList1.Item(Ishi_Bango * 4) & " 手目" & vbLf
            End If
            Label0(3).Text = "★ 再生画面です。自動または手動で再生してください。"

            On Error Resume Next
            PlaySound(Onsei1, 0, SND_ASYNC)

            Call 石と手順番号を描画(Grid, CInt(ArrayList1.Item(Ishi_Bango * 4)), CStr(ArrayList1.Item(Ishi_Bango * 4 + 1)), _
                                          CInt(ArrayList1.Item(Ishi_Bango * 4 + 2)), CInt(ArrayList1.Item(Ishi_Bango * 4 + 3)))
            '▼再生が終了した場合
            If Ishi_Bango = CInt(ArrayList1.Item(ArrayList1.Count - 4)) Then
                Label2(0).Text = "      ◎ 再生終了です。" & vbLf & vbLf & "    最終着手は「" & ArrayList1.Item(ArrayList1.Count - 4) & "手目」です。" & vbLf & vbLf _
                         & "  盤面にアクセスするには再生終了ボ" & vbLf & "  タンをクリックして下さい。"
                Label0(1).Text = "☆　「" & ArrayList1.Item(ArrayList1.Count - 4) & "手目」で 再生終了です。"
                Label0(3).Text = "★ 再生終了です。盤面にアクセスするには再生終了ボタンをクリックして下さい。"

                Button2(0).Enabled = False
                Button2(1).Enabled = False
                Button2(2).Enabled = True
                Button2(3).Enabled = True
                Button2(4).Enabled = False
                Button2(5).Enabled = False
                Button2(6).Enabled = True
                RadioButton1(0).Enabled = False
                RadioButton1(1).Enabled = False
                RadioButton1(2).Enabled = False
            End If
        End If
    End Sub
#End Region

#Region "サブ⇒最後へ"
    Private Sub 最後へ()
        Call 石のクリヤー(Grid)

        '▼置碁の場合は石を置き直す
        If Okigo = True Then
            Dim Hdc As Handicap = New Handicap(OkigoMoku)
            Hdc.Mokusu(Grid)
            Label0(1).Text = Hdc.MyLabel1
            Label0(2).Text = Hdc.MyLabel2
        End If

        Call 自動再生(0)
        Ishi_Bango = CInt(ArrayList1.Item(ArrayList1.Count - 4))

        On Error Resume Next
        PlaySound(Onsei1, 0, SND_ASYNC)
    End Sub
#End Region

#Region "サブ⇒印刷データのチェック"
    Dim Ck As Boolean 'データチェック用

    Private Sub 印刷データのチェック(ByVal a As Integer, ByVal b As Integer, ByVal c As Integer)
        '▼空白のチェック
        If TextBox2(a).Text = "" Or TextBox2(b).Text = "" Then
            MsgBox("空白です。 第" & c & "譜の印刷の範囲をインプットして下さい")
            RadioButton1(a).Checked = True
            TextBox2(b).Focus()
            Ck = True
            Exit Sub
        End If
        '▼数字の大小のチェック
        If CInt(TextBox2(a).Text) >= CInt(TextBox2(b).Text) Then
            MsgBox("インプットした数字が間違っています。入れ直して下さい。")
            RadioButton1(a).Checked = True
            TextBox2(b).Text = ""
            TextBox2(b).Focus()
            Ck = True
            Exit Sub
        End If
        '▼数字が最終着手番号より大きい場合のチェック
        If CInt(TextBox2(b).Text) > CInt(ArrayList1.Item(ArrayList1.Count - 4)) Then
            MsgBox("最終着手手順は 「" & CInt(ArrayList1.Item(ArrayList1.Count - 4)) & "手目」 です。それ以下の数字を入れ直して下さい。")
            RadioButton1(a).Checked = True
            TextBox2(b).Text = ""
            TextBox2(b).Focus()
            Ck = True
            Exit Sub
        End If
        '▼手順表示個数が80項目以上か
        If CInt(TextBox2(b).Text) - CInt(TextBox2(a).Text) + 1 > 80 Then
            EndPage = 2
            'MsgBox("印刷ページは２ページにまたがります")
            Ck = False
        End If
        '▼数字の最大値のチェック(最大の着手手順以下である場合)
        If a = 4 And b = 9 And c = 5 Then '第5譜印刷の場合のみ
            Button2(b).Enabled = True
            Button2(11).Enabled = True
            Ck = False
            Exit Sub
        End If

        If CInt(TextBox2(b).Text) = CInt(ArrayList1.Item(ArrayList1.Count - 4)) Then
            RadioButton1(c).Enabled = False
            TextBox2(c).Text = ""
        Else
            RadioButton1(c).Enabled = True
            TextBox2(c).Text = TextBox2(b).Text + 1
        End If
        Button2(b).Enabled = True
        Button2(11).Enabled = True
        Ck = False
    End Sub
#End Region

#Region "サブ⇒印刷データの表示"
    Private Sub 印刷データの表示(ByVal a As Integer, ByVal b As Integer)
        Call 石のクリヤー(Grid)

        '▼着手番号の印字範囲を指定する
        Start_Bango = CInt(TextBox2(a).Text)
        End_Bango = CInt(TextBox2(b).Text)

        '▼置碁の場合は石を置き直す
        If Okigo = True Then
            Dim Hdc As Handicap = New Handicap(OkigoMoku)
            Hdc.Mokusu(Grid)
            Label0(1).Text = Hdc.MyLabel1
            Label0(2).Text = Hdc.MyLabel2
        End If

        '▼ArrayList1のデータ通り石と手順番号を再描画する
        For i As Integer = 0 To (End_Bango - 1) * 4 Step 4
            Call 石と手順番号を描画(Grid, CInt(ArrayList1.Item(i)), CStr(ArrayList1.Item(i + 1)), _
                                          CInt(ArrayList1.Item(i + 2)), CInt(ArrayList1.Item(i + 3)))
        Next

        Label0(1).Text = "印刷画面です。この棋譜を印刷します。"
        Label2(1).Text = Label0(0).Text
        Label2(2).Text = "--最終着手は " & ArrayList1.Item(ArrayList1.Count - 4) & " 手目です--"
    End Sub
#End Region

#Region "サブ⇒印刷プレビュー"
    Private Sub 印刷プレビュー()
        Dim PrintDocument1 As New System.Drawing.Printing.PrintDocument          'PrintDocumentオブジェクトの作成
        AddHandler PrintDocument1.PrintPage, AddressOf PrintDocument1_PrintPage  'PrintPageイベントハンドラの追加

        Dim PrintPreviewDialog1 As New System.Windows.Forms.PrintPreviewDialog   'PrintPreviewDialogオブジェクトの作成
        With PrintPreviewDialog1
            .ClientSize = New Size(Screen.PrimaryScreen.Bounds.Width * 0.75, Screen.PrimaryScreen.Bounds.Height * 0.9)
            .StartPosition = FormStartPosition.CenterScreen
            .PrintPreviewControl.Zoom = 0.8
            .UseAntiAlias = True                                                'ギザギザを目立たなくする
            .Document = PrintDocument1                                          'プレビューするPrintDocumentを設定
            .ShowDialog()                                                       '印刷プレビューダイアログを表示する
        End With
    End Sub
#End Region

#Region "サブ⇒印刷"
    Private EndPage As Integer = 1     '最大印刷ページ
    Private CurrentPage As Integer = 0 '現在の印刷ページ
    Private NextPage As Boolean        '次の印刷ページがあるか、無いか(True⇒ある、False⇒無い)


    Private Sub 印刷()
        Dim PrintDocument1 As New System.Drawing.Printing.PrintDocument          'PrintDocumentオブジェクトの作成
        AddHandler PrintDocument1.PrintPage, AddressOf PrintDocument1_PrintPage  'PrintPageイベントハンドラの追加

        Dim PrintDialog1 As New PrintDialog                                      'PrintDialogクラスの作成
        With PrintDialog1
            .Document = PrintDocument1                                           'PrintDocumentを指定
            .AllowSomePages = True                                               'ページ指定できるようにする
            .PrinterSettings.MinimumPage = 1                                     'ページ指定の最小値と最大値を指定する
            .PrinterSettings.MaximumPage = EndPage
            .PrinterSettings.FromPage = PrintDialog1.PrinterSettings.MinimumPage '印刷開始と終了ページを指定する
            .PrinterSettings.ToPage = PrintDialog1.PrinterSettings.MaximumPage
        End With

        If PrintDialog1.ShowDialog() = DialogResult.OK Then                      '印刷の選択ダイアログを表示する
            PrintDocument1.Print()                                               'OKがクリックされた時は印刷する
        Else
            Exit Sub
        End If
    End Sub


#Region "PrintDocument1_PrintPage"
    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        CurrentPage += 1        '印刷ページのカウント

        Select Case CurrentPage
            Case 1
                Dim Prt As New Print(e)
                Prt.Insatsu(e, Page, CurrentPage)

                If End_Bango - Start_Bango + 1 > 80 Then
                    e.HasMorePages = True
                Else
                    e.HasMorePages = False
                End If
            Case 2
                Dim Prt As New Print(e)
                Prt.Insatsu(e, Page, CurrentPage)

                e.HasMorePages = False
        End Select
    End Sub
#End Region


#End Region


#End Region



#Region "Button2_MouseEnter or Button_MouseLeave⇒マウスがボタン上にきた時又は失ったとき<再生>"
    Public Sub Button2_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs)
        Select Case CInt(CType(sender, Button).Tag)
            Case 2 To 5
                Button2(CInt(CType(sender, Button).Tag)).BackColor = Color.FromArgb(245, 177, 170)
            Case Else
                Exit Sub
        End Select
    End Sub

    Public Sub Button2_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs)
        Select Case CInt(CType(sender, Button).Tag)
            Case 2 To 5
                Button2(CInt(CType(sender, Button).Tag)).BackColor = Color.FromArgb(245, 245, 245)
            Case Else
                Exit Sub
        End Select
    End Sub
#End Region



#Region "RadioButton1_CheckedChanged⇒ラジオボタンがチェックされたとき<印刷>"
    Public Sub RadioButton1_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Select Case CInt(sender.Tag)
            Case 0
                Call すべてロック()
                Button2(0).Enabled = True
                TextBox2(0).Enabled = True
                TextBox2(5).Enabled = True
                TextBox2(5).Focus()
            Case 1
                Call すべてロック()
                Button2(1).Enabled = True
                TextBox2(1).Enabled = True
                TextBox2(6).Enabled = True
                TextBox2(6).Focus()
            Case 2
                Call すべてロック()
                Button2(2).Enabled = True
                TextBox2(2).Enabled = True
                TextBox2(7).Enabled = True
                TextBox2(7).Focus()
            Case 3
                Call すべてロック()
                Button2(3).Enabled = True
                TextBox2(3).Enabled = True
                TextBox2(8).Enabled = True
                TextBox2(8).Focus()
            Case 4
                Call すべてロック()
                Button2(4).Enabled = True
                TextBox2(4).Enabled = True
                TextBox2(9).Enabled = True
                TextBox2(9).Focus()
        End Select

        On Error Resume Next
        PlaySound(Onsei1, 0, SND_ASYNC)
    End Sub


#Region "すべてロック"
    Private Sub すべてロック()
        For i As Integer = 0 To 9
            TextBox2(i).Enabled = False
            Button2(i).Enabled = False
        Next
        Button2(11).Enabled = False

        Ishi_Bango = 0
    End Sub
#End Region


#End Region



#Region "TextBox2_KeyPress ⇒テキストボックスに入力されたとき<印刷>"
    Public Sub TextBox2_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs)
        '----------------------------------------------------------------------数字とバックキーのみ入力可
        If (e.KeyChar < "0"c Or e.KeyChar > "9"c) And e.KeyChar <> vbBack Then
            e.Handled = True
        End If

    End Sub
#End Region



End Class
