﻿Public Class Print



    Dim X As Integer       '碁盤のセル表示開始x物理座標
    Dim Y As Integer       '碁盤のセル表示開始y物理座標



#Region "Public Sub New"
    Public Sub New(ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        Dim left As Integer = e.MarginBounds.Left     'マージン⇒100
        Dim top As Integer = e.MarginBounds.Top       'マージン⇒100

        X = left + 50       '碁盤のセル表示開始x物理座標
        Y = top + 130       '碁盤のセル表示開始y物理座標
    End Sub
#End Region



#Region "Insatsu⇒印刷する"
    Public Sub Insatsu(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal Page As Integer, ByVal CurrentPage As Integer)
        If CurrentPage = 1 Then

            If Page = 1 Then '------------------------------------Page1～5 ⇒ 第1譜～第5譜まで
                Call 表題を書く(e)
            End If

            Call 盤の線を描く(e)
            Call 盤に石・着手番号を描く(e, Page)
            Call 着手手順を書く(e, CurrentPage)

        ElseIf CurrentPage = 2 Then '-----------------------------CurrentPage1～2 ⇒ 第1～5譜が2枚になる場合
            Call 着手手順を書く(e, CurrentPage)

        End If
    End Sub
#End Region



#Region "サブ⇒表題を書く"
    Private Sub 表題を書く(ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        e.Graphics.DrawString(Label0(0).Text, New Font("ＭＳ ゴシック", 16, FontStyle.Bold Or FontStyle.Underline), Brushes.Black, X + 130, Y - 130)
        e.Graphics.DrawString("対局日　　" & "  平成" & TextBox1(0).Text & "年" & TextBox1(1).Text & "月" & TextBox1(2).Text & "日", _
                                                            New Font("ＭＳ ゴシック", 11), Brushes.Black, X + 350, Y - 100)
        e.Graphics.DrawString("対局者　　" & "(白) " & TextBox1(3).Text, New Font("ＭＳ ゴシック", 11), Brushes.Black, X + 350, Y - 80)
        e.Graphics.DrawString("   " & TextBox1(5).Text & ComboBox1(0).Text, New Font("ＭＳ ゴシック", 11), Brushes.Black, X + 530, Y - 80)
        e.Graphics.DrawString("      　　" & "(黒) " & TextBox1(4).Text, New Font("ＭＳ ゴシック", 11), Brushes.Black, X + 350, Y - 60)
        e.Graphics.DrawString("   " & TextBox1(6).Text & ComboBox1(1).Text, New Font("ＭＳ ゴシック", 11), Brushes.Black, X + 530, Y - 60)
        If Okigo = True Then
            e.Graphics.DrawString("( " & OkigoMoku & "  子  局 )", New Font("ＭＳ ゴシック", 10, FontStyle.Bold), Brushes.Black, X + 130, Y - 70)
        End If
    End Sub
#End Region



#Region "サブ⇒盤の線を描く"
    Private Sub 盤の線を描く(ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        '------------------盤の輪郭
        Dim Width_X As Integer = 540
        Dim Height_Y As Integer = 540
        e.Graphics.DrawRectangle(New Pen(Color.Black, 2), X, Y, Width_X, Height_Y)

        '-----------------縦の17本の線
        For i As Integer = 1 To 17
            e.Graphics.DrawLine(New Pen(Color.Black, 1), X + i * CInt(Width_X / 18), Y, X + i * CInt(Width_X / 18), Y + Height_Y)
        Next

        '-----------------横の17本の線
        For i As Integer = 1 To 17
            e.Graphics.DrawLine(New Pen(Color.Black, 1), X, Y + i * CInt(Height_Y / 18), X + 540, Y + i * CInt(Height_Y / 18))
        Next

        '------------------９個の星
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 3 - 3, Y + CInt(Height_Y / 18) * 3 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 9 - 3, Y + CInt(Height_Y / 18) * 3 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 15 - 3, Y + CInt(Height_Y / 18) * 3 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 3 - 3, Y + CInt(Height_Y / 18) * 9 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 9 - 3, Y + CInt(Height_Y / 18) * 9 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 15 - 3, Y + CInt(Height_Y / 18) * 9 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 3 - 3, Y + CInt(Height_Y / 18) * 15 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 9 - 3, Y + CInt(Height_Y / 18) * 15 - 3, 6, 6)
        e.Graphics.FillEllipse(Brushes.Black, X + CInt(Width_X / 18) * 15 - 3, Y + CInt(Height_Y / 18) * 15 - 3, 6, 6)

        '--------------------X軸の数字
        For i As Integer = 0 To 18
            Select Case i
                Case 0 To 8
                    e.Graphics.DrawString(i + 1, New Font("ＭＳ 明朝", 10.5, FontStyle.Bold), Brushes.Black, (X + i * CInt(Width_X / 18)) - 6, Y - 28, New StringFormat)
                Case 9 To 18
                    e.Graphics.DrawString(i + 1, New Font("ＭＳ 明朝", 10.5, FontStyle.Bold), Brushes.Black, (X + i * CInt(Width_X / 18)) - 11, Y - 28, New StringFormat)
            End Select
        Next

        '--------------------Y軸の数字
        Dim Suzi As String = ""
        For i As Integer = 0 To 18
            Select Case i
                Case 0
                    Suzi = "一"
                Case 1
                    Suzi = "ニ"
                Case 2
                    Suzi = "三"
                Case 3
                    Suzi = "四"
                Case 4
                    Suzi = "五"
                Case 5
                    Suzi = "六"
                Case 6
                    Suzi = "七"
                Case 7
                    Suzi = "八"
                Case 8
                    Suzi = "九"
                Case 9
                    Suzi = "十"
                Case 10
                    Suzi = "十一"
                Case 11
                    Suzi = "十二"
                Case 12
                    Suzi = "十三"
                Case 13
                    Suzi = "十四"
                Case 14
                    Suzi = "十五"
                Case 15
                    Suzi = "十六"
                Case 16
                    Suzi = "十七"
                Case 17
                    Suzi = "十八"
                Case 18
                    Suzi = "十九"
            End Select

            Select Case i
                Case 0 To 9
                    e.Graphics.DrawString(Suzi, New Font("ＭＳ 明朝", 9, FontStyle.Bold), Brushes.Black, X - 30, (Y + i * CInt(Height_Y / 18)) - 5, New StringFormat)
                Case 10 To 18
                    e.Graphics.DrawString(Suzi, New Font("ＭＳ 明朝", 9, FontStyle.Bold), Brushes.Black, X - 45, (Y + i * CInt(Height_Y / 18)) - 6, New StringFormat)
            End Select

        Next
    End Sub
#End Region



#Region "サブ⇒盤に石・着手番号を描く"
    Private Sub 盤に石・着手番号を描く(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal Page As Integer)
        '------------------第１～５譜の文
        e.Graphics.DrawString("<第 " & Page & " 譜>", New Font("ＭＳ ゴシック", 14, FontStyle.Bold), Brushes.Black, X + 10, Y - 60)
        If End_Bango = CInt(ArrayList1.Item(ArrayList1.Count - 4)) Then
            e.Graphics.DrawString(Start_Bango & "手目 ～ " & End_Bango & "手目まで (完)", New Font("ＭＳ ゴシック", 10), Brushes.Black, X + 120, Y - 55)
        Else
            e.Graphics.DrawString(Start_Bango & "手目 ～ " & End_Bango & "手目まで", New Font("ＭＳ ゴシック", 10), Brushes.Black, X + 120, Y - 55)
        End If

        '------------------石・着手番号を描く
        For Col As Integer = 0 To 18
            For Row As Integer = 0 To 18
                If Form1.Grid.Cells(Row, Col).Status <> CellStatus.Nothing Then
                    Dim Isi_x As Integer = X + Row * 30 - 15        '石の印刷物理x座標
                    Dim Isi_y As Integer = Y + Col * 30 - 15        '石の印刷物理y座標

                    '▼劫などで同じ番号が複数ある場合には最後の着手番号とする
                    Dim Bango As Integer = 0
                    For i As Integer = 0 To ArrayList1.Count - 4 Step 4
                        If ArrayList1.Item(i + 2) = Row And ArrayList1.Item(i + 3) = Col Then
                            Bango = CInt(ArrayList1.Item(i))
                        End If
                        If i >= (End_Bango - 1) * 4 Then Exit For
                    Next

                    '▼着手番号印刷位置の微調整
                    Dim a As Integer
                    Select Case Bango
                        Case 1 To 9
                            a = 6
                        Case 10 To 99
                            a = 9
                        Case Else
                            a = 12
                    End Select

                    Dim Bango_x As Integer = X + Row * 30 - a  '着手番号の印刷物理x座標
                    Dim Bango_y As Integer = Y + Col * 30 - 6  '着手番号の印刷物理y座標

                    If Form1.Grid.Cells(Row, Col).Status = CellStatus.Black Then
                        '▼黒石の描画
                        e.Graphics.FillEllipse(Brushes.Black, Isi_x, Isi_y, 29, 29)
                        '▼黒石の着手番号の記入
                        If Bango <> 0 Then '置き石には番号を描かない
                            If Bango >= Start_Bango Then
                                e.Graphics.DrawString(Bango, New Font("ＭＳ ゴシック", 9, FontStyle.Bold), Brushes.White, Bango_x, Bango_y)
                            End If
                        End If

                    ElseIf Form1.Grid.Cells(Row, Col).Status = CellStatus.White Then
                        '▼白石の描画
                        e.Graphics.FillEllipse(Brushes.White, Isi_x, Isi_y, 29, 29) '白で塗りつぶす
                        e.Graphics.DrawEllipse(Pens.Black, Isi_x, Isi_y, 29, 29)    '黒い輪郭
                        '▼白石の着手番号の記入
                        If Bango >= Start_Bango Then
                            e.Graphics.DrawString(Bango, New Font("ＭＳ ゴシック", 9, FontStyle.Bold), Brushes.Black, Bango_x, Bango_y)
                        End If

                    End If
                End If
            Next
        Next
    End Sub
#End Region



#Region "サブ⇒着手手順を書く"
    Dim BangoD As Integer
    Dim IroD As String
    Dim XD As String
    Dim YD As String

    Private Sub 着手手順を書く(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal CurrentPage As Integer)

        If CurrentPage = 1 Then

            Dim Row As Integer = X - 50  '着手手順を書く原点x
            Dim Col As Integer = Y + 570 '着手手順を書く原点y

            '▼列数を決める
            Dim Retsu As Integer
            Select Case (End_Bango - Start_Bango + 1)
                Case 1 To 20
                    Retsu = 1
                Case 21 To 40
                    Retsu = 2
                Case 41 To 60
                    Retsu = 3
                Case 61 To 80
                    Retsu = 4
                Case Is > 80
                    Retsu = 4
            End Select

            Dim Rows As Integer = 1

            Dim End_NO As Integer = End_Bango
            If End_Bango - Start_Bango + 1 > 80 Then End_NO = Start_Bango + 80 - 1

            For i As Integer = (Start_Bango - 1) * 4 To (End_NO - 1) * 4 Step 4
                BangoD = CInt(ArrayList1.Item(i))
                IroD = CStr(ArrayList1.Item(i + 1))
                XD = CStr(ArrayList1.Item(i + 2) + 1)
                YD = CStr(ArrayList1.Item(i + 3) + 1)
                Call 桁揃え()

                Dim Row1 As Integer = 0
                Dim Col1 As Integer = 0

                Select Case Retsu
                    Case 1 '-------------1列の場合
                        Row1 = Row + 260
                        Col1 = Col + (Rows - 1) * 14
                    Case 2 '2-------------列の場合
                        Select Case Rows
                            Case 1 To 20
                                Row1 = Row + 150
                                Col1 = Col + (Rows - 1) * 14
                            Case 21 To 40
                                Row1 = Row + 360
                                Col1 = Col + (Rows - 21) * 14
                        End Select
                    Case 3 '-------------3列の場合
                        Select Case Rows
                            Case 1 To 20
                                Row1 = Row + 80
                                Col1 = Col + (Rows - 1) * 14
                            Case 21 To 40
                                Row1 = Row + 255
                                Col1 = Col + (Rows - 21) * 14
                            Case 41 To 60
                                Row1 = Row + 430
                                Col1 = Col + (Rows - 41) * 14
                        End Select
                    Case 4 '-------------4列の場合
                        Select Case Rows
                            Case 1 To 20
                                Row1 = Row
                                Col1 = Col + (Rows - 1) * 14
                            Case 21 To 40
                                Row1 = Row + 170
                                Col1 = Col + (Rows - 21) * 14
                            Case 41 To 60
                                Row1 = Row + 340
                                Col1 = Col + (Rows - 41) * 14
                            Case 61 To 80
                                Row1 = Row + 510
                                Col1 = Col + (Rows - 61) * 14
                        End Select
                End Select

                Select Case BangoD
                    Case 0 To 9
                        e.Graphics.DrawString("  " & BangoD & " : " & IroD & " (" & XD & "," & YD & ")", New Font("ＭＳ ゴシック", 9), Brushes.Black, Row1, Col1)
                    Case 10 To 99
                        e.Graphics.DrawString(" " & BangoD & " : " & IroD & " (" & XD & "," & YD & ")", New Font("ＭＳ ゴシック", 9), Brushes.Black, Row1, Col1)
                    Case Is >= 100
                        e.Graphics.DrawString(BangoD & " : " & IroD & " (" & XD & "," & YD & ")", New Font("ＭＳ ゴシック", 9), Brushes.Black, Row1, Col1)
                End Select

                Rows += 1
            Next



        ElseIf CurrentPage = 2 Then '***************************************<<2ペジになる場合>>*****************************************
            Dim RowD As Integer   '着手手順を書く原点x
            Dim ColD As Integer   '着手手順を書く原点y

            Dim Row1 As Integer   '個々の着手手順のx
            Dim Col1 As Integer   '個々の着手手順のy

            Dim RowsD As Integer = 1
            For i As Integer = (Start_Bango - 1 + 80) * 4 To (End_Bango - 1) * 4 Step 4
                Select Case RowsD
                    Case 1 To 80      '第1段落の原点x
                        RowD = X - 50
                        ColD = Y - 120
                    Case 81 To 160    '第2段落の原点x
                        RowD = X - 50
                        ColD = Y + 225
                    Case 161 To 240   '第3段落の原点x
                        RowD = X - 50
                        ColD = Y + 570
                    Case Else
                        Exit Sub
                End Select

                Select Case RowsD
                    Case 1 To 20
                        Row1 = RowD
                        Col1 = ColD + (RowsD - 1) * 14
                    Case 21 To 40
                        Row1 = RowD + 170
                        Col1 = ColD + (RowsD - 21) * 14
                    Case 41 To 60
                        Row1 = RowD + 340
                        Col1 = ColD + (RowsD - 41) * 14
                    Case 61 To 80
                        Row1 = RowD + 510
                        Col1 = ColD + (RowsD - 61) * 14

                    Case 81 To 100
                        Row1 = RowD
                        Col1 = ColD + (RowsD - 80 - 1) * 14
                    Case 101 To 120
                        Row1 = RowD + 170
                        Col1 = ColD + (RowsD - 80 - 21) * 14
                    Case 121 To 140
                        Row1 = RowD + 340
                        Col1 = ColD + (RowsD - 80 - 41) * 14
                    Case 141 To 160
                        Row1 = RowD + 510
                        Col1 = ColD + (RowsD - 80 - 61) * 14

                    Case 161 To 180
                        Row1 = RowD
                        Col1 = ColD + (RowsD - 160 - 1) * 14
                    Case 181 To 200
                        Row1 = RowD + 170
                        Col1 = ColD + (RowsD - 160 - 21) * 14
                    Case 201 To 220
                        Row1 = RowD + 340
                        Col1 = ColD + (RowsD - 160 - 41) * 14
                    Case 221 To 240
                        Row1 = RowD + 510
                        Col1 = ColD + (RowsD - 160 - 61) * 14
                    Case Else
                        Exit Sub
                End Select

                BangoD = CInt(ArrayList1.Item(i))
                IroD = CStr(ArrayList1.Item(i + 1))
                XD = CStr(ArrayList1.Item(i + 2) + 1)
                YD = CStr(ArrayList1.Item(i + 3) + 1)
                Call 桁揃え()

                Select Case BangoD
                    Case 0 To 9
                        e.Graphics.DrawString("  " & BangoD & " : " & IroD & " (" & XD & "," & YD & ")", New Font("ＭＳ ゴシック", 9), Brushes.Black, Row1, Col1)
                    Case 10 To 99
                        e.Graphics.DrawString(" " & BangoD & " : " & IroD & " (" & XD & "," & YD & ")", New Font("ＭＳ ゴシック", 9), Brushes.Black, Row1, Col1)
                    Case Is >= 100
                        e.Graphics.DrawString(BangoD & " : " & IroD & " (" & XD & "," & YD & ")", New Font("ＭＳ ゴシック", 9), Brushes.Black, Row1, Col1)
                End Select

                RowsD += 1
            Next



        End If
    End Sub



#Region "サブ⇒サブ⇒桁揃え"
    Private Sub 桁揃え()
        If IroD = "Black" Then IroD = "●"
        If IroD = "White" Then IroD = "○"

        If XD = "1" Then XD = "  １"
        If XD = "2" Then XD = "  ２"
        If XD = "3" Then XD = "  ３"
        If XD = "4" Then XD = "  ４"
        If XD = "5" Then XD = "  ５"
        If XD = "6" Then XD = "  ６"
        If XD = "7" Then XD = "  ７"
        If XD = "8" Then XD = "  ８"
        If XD = "9" Then XD = "  ９"
        If XD = "10" Then XD = "１０"
        If XD = "11" Then XD = "１１"
        If XD = "12" Then XD = "１２"
        If XD = "13" Then XD = "１３"
        If XD = "14" Then XD = "１４"
        If XD = "15" Then XD = "１５"
        If XD = "16" Then XD = "１６"
        If XD = "17" Then XD = "１７"
        If XD = "18" Then XD = "１８"
        If XD = "19" Then XD = "１９"

        If YD = "1" Then YD = "  一"
        If YD = "2" Then YD = "  ニ"
        If YD = "3" Then YD = "  三"
        If YD = "4" Then YD = "  四"
        If YD = "5" Then YD = "  五"
        If YD = "6" Then YD = "  六"
        If YD = "7" Then YD = "  七"
        If YD = "8" Then YD = "  八"
        If YD = "9" Then YD = "  九"
        If YD = "10" Then YD = "  十"
        If YD = "11" Then YD = "十一"
        If YD = "12" Then YD = "十二"
        If YD = "13" Then YD = "十三"
        If YD = "14" Then YD = "十四"
        If YD = "15" Then YD = "十五"
        If YD = "16" Then YD = "十六"
        If YD = "17" Then YD = "十七"
        If YD = "18" Then YD = "十八"
        If YD = "19" Then YD = "十九"
    End Sub
#End Region



#End Region



End Class
